// DlgAlarmCenterNetCfg.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgAlarmCenterNetCfg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgAlarmCenterNetCfg dialog


CDlgAlarmCenterNetCfg::CDlgAlarmCenterNetCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAlarmCenterNetCfg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAlarmCenterNetCfg)
	m_csAuxiliaryAddr = _T("");
	m_iAuxiliaryPort = 0;
	//}}AFX_DATA_INIT
}


void CDlgAlarmCenterNetCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAlarmCenterNetCfg)
	DDX_Text(pDX, IDC_EDT_AUXILIARY_ADDR, m_csAuxiliaryAddr);
	DDX_Text(pDX, IDC_EDT_AUXILIARY_PORT, m_iAuxiliaryPort);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgAlarmCenterNetCfg, CDialog)
	//{{AFX_MSG_MAP(CDlgAlarmCenterNetCfg)
	ON_BN_CLICKED(IDC_BTN_GET, OnBtnGet)
	ON_BN_CLICKED(IDC_BTN_SET, OnBtnSet)
	ON_WM_CANCELMODE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAlarmCenterNetCfg message handlers

void CDlgAlarmCenterNetCfg::OnBtnGet() 
{
	// TODO: Add your control notification handler code here

	NET_DVR_ALARMCENTER_NETCFG struAlarmCenterNetCfg = {0};
	struAlarmCenterNetCfg.dwSize = sizeof(NET_DVR_ALARMCENTER_NETCFG);

	DWORD dwReturn = -1;
	char szLan[128] = {0};

	if (!NET_DVR_GetDVRConfig(m_lUserID, NET_DVR_GET_ALARMCENTER_NETCFG, 0, &struAlarmCenterNetCfg, sizeof(struAlarmCenterNetCfg), &dwReturn))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GET_ALARMCENTER_NETCFG");
		g_StringLanType(szLan, "ȡʧ", "Get alarm center network paramter failed!");
		MessageBox(szLan);
		return;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_ALARMCENTER_NETCFG");
		g_StringLanType(szLan, "ȡɹ", "Get alarm center network paramter Successful!");
	}

	m_iAuxiliaryPort = (int)struAlarmCenterNetCfg.wAuxiliaryAlarmPort;
	char czAuxiliaryAddr[MAX_DOMAIN_NAME+1] = {0};
	memcpy(czAuxiliaryAddr, struAlarmCenterNetCfg.byAuxiliaryAlarmAddr, MAX_DOMAIN_NAME);
	m_csAuxiliaryAddr = czAuxiliaryAddr;

	UpdateData(FALSE);
}

void CDlgAlarmCenterNetCfg::OnBtnSet() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	NET_DVR_ALARMCENTER_NETCFG struAlarmCenterNetCfg = {0};
	struAlarmCenterNetCfg.dwSize = sizeof(NET_DVR_ALARMCENTER_NETCFG);

	struAlarmCenterNetCfg.wAuxiliaryAlarmPort = m_iAuxiliaryPort;
	memcpy(struAlarmCenterNetCfg.byAuxiliaryAlarmAddr, m_csAuxiliaryAddr, MAX_DOMAIN_NAME);

	char szLan[128] = {0};

	if (!NET_DVR_SetDVRConfig(m_lUserID, NET_DVR_SET_ALARMCENTER_NETCFG, 0, &struAlarmCenterNetCfg, sizeof(struAlarmCenterNetCfg)))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SET_ALARMCENTER_NETCFG");
		g_StringLanType(szLan, "ñʧ", "Set alarm center network paramter Failed");
		MessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SET_ALARMCENTER_NETCFG");
		g_StringLanType(szLan, "ñɹ", "Set alarm center network paramter Successful");
	}
}

BOOL CDlgAlarmCenterNetCfg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();
	m_lUserID = g_struDeviceInfo[m_iDeviceIndex].lLoginID;
	
	OnBtnGet();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
