#if !defined(AFX_DLGMASTERSLAVETRACKING_H__F14CEFD2_564A_4D98_8724_B80FD67EC9D9__INCLUDED_)
#define AFX_DLGMASTERSLAVETRACKING_H__F14CEFD2_564A_4D98_8724_B80FD67EC9D9__INCLUDED_
#include "VcaCommonOperations.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgMasterSlaveTracking.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDlgMasterSlaveTracking dialog

class CDlgMasterSlaveTracking : public CDialog,public CVcaCommonOperations
{
// Construction
public:
	CDlgMasterSlaveTracking(CWnd* pParent = NULL);   // standard constructor
	~CDlgMasterSlaveTracking();
// Dialog Data
	//{{AFX_DATA(CDlgMasterSlaveTracking)
	enum { IDD = IDD_DLG_MASTER_SLAVE_TRACKING };
	CComboBox	m_comboTrackMode;
	CComboBox	m_comboCalibMode;
	CListCtrl	m_lstCalib;
	CComboBox	m_comboSlaveCameraID;
	int		m_iTrackingTime;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgMasterSlaveTracking)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgMasterSlaveTracking)
	afx_msg void OnBtnLoginSlave1();
	afx_msg void OnBtnPreviewSlave();
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnPtz();
	afx_msg void OnBtnReflashSlaveStatus();
	afx_msg void OnBtnTackingratio();
	afx_msg void OnBtnSave();
	afx_msg void OnBtnRefush();
	afx_msg void OnBtnTrackcfg();
	afx_msg void OnBtnCalib();
	afx_msg void OnBtnCalibDel();
	afx_msg void OnSelchangeComboTrackmode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	

public:
    LONG m_lChannel;
    LONG m_lLoginID;
	LONG m_lPlayHandle[5];
	BOOL Play(NET_DVR_CLIENTINFO* struClientInfo, LONG loginID, int index);
	BOOL SlaveLoginPlay(char *sDVRIP, WORD wDVRPort, char *sUserName, char *sPassword, NET_DVR_CLIENTINFO* struClientInfo, int index);
	LONG m_iDeviceIndex;
	char m_szStatusBuf[1024];
    LONG m_lUserID[5];
	CRect   m_rcWnd;
	NET_DVR_SLAVECAMERA_COND m_struSlaveCameraCond;
	NET_DVR_SLAVECAMERA_CFG m_struSlaveCameraCfg;
	NET_DVR_SLAVECAMERA_STATUS m_struSlaveCameraStatus;
	NET_DVR_SLAVECAMERA_CALIB_CFG m_struSlaveCameraCalibCfg;
	NET_DVR_TRACK_MODE m_struTrackMode;
	NET_DVR_TRACKING m_struTracking;
	BOOL m_bTrackMode;

	BOOL GetDataFromCalibList();
	BOOL SetDataToCalibList(NET_DVR_SLAVECAMERA_CALIB_CFG* m_struSlaveCameraCalibCfg);
	BOOL SetPoint();

	void F_DrawFrame(HDC hDc);
	BOOL m_bCloseIn;
	BOOL m_bMouseMove;
	NET_VCA_POLYGON m_struRegionTemp;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGMASTERSLAVETRACKING_H__F14CEFD2_564A_4D98_8724_B80FD67EC9D9__INCLUDED_)
