// DlgRecordHostCfg.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgRecordHostCfg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DlgRecordHostCfg dialog


DlgRecordHostCfg::DlgRecordHostCfg(CWnd* pParent /*=NULL*/)
	: CDialog(DlgRecordHostCfg::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgRecordHostCfg)
	m_DelayTime = 0;
	//}}AFX_DATA_INIT
	m_lUserID = 0;
	m_iDeviceIndex = 0;
	memset(&m_struRecordHostCfg, 0 ,sizeof(m_struRecordHostCfg));
	m_iStartChannel = 0;
	m_iMirrorNum = 0;
}


void DlgRecordHostCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgRecordHostCfg)
	DDX_Control(pDX, IDC_COMBO_RECORD_TYPE, m_comRecordType);
	DDX_Text(pDX, IDC_DELAY_TIME, m_DelayTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgRecordHostCfg, CDialog)
	//{{AFX_MSG_MAP(DlgRecordHostCfg)
	ON_BN_CLICKED(IDC_BTN_SET, OnBtnSet)
	ON_BN_CLICKED(IDC_BTN_GET, OnBtnGet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DlgRecordHostCfg message handlers

BOOL DlgRecordHostCfg::OnInitDialog()
{
	CDialog::OnInitDialog();
	OnBtnGet();
	return TRUE;
}

void DlgRecordHostCfg::OnBtnSet() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char szLan[128] = {0};
	m_struRecordHostCfg.byDirectedMode = m_comRecordType.GetCurSel();
	m_struRecordHostCfg.dwOneKeyDelayTime = m_DelayTime;
	if(!NET_DVR_SetDVRConfig(m_lUserID,NET_DVR_SET_RECORDINGHOST_CFG,m_iStartChannel,&m_struRecordHostCfg,sizeof(m_struRecordHostCfg)))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GET_RECORDINGHOST_CFG,  %s", "Set Record host cfg faild");
		g_StringLanType(szLan, "¼ʧ", "Set Record host cfg failed");
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_RECORDINGHOST_CFG,  %s", "Set Record host cfg success");
		g_StringLanType(szLan, "¼óɹ", "Set Record host cfg success");
		AfxMessageBox(szLan);
	}
}

void DlgRecordHostCfg::OnBtnGet() 
{
	// TODO: Add your control notification handler code here
	DWORD dwReturned = 0;
	char szLan[128] = {0};
	if(!NET_DVR_GetDVRConfig(m_lUserID,NET_DVR_GET_RECORDINGHOST_CFG,m_iStartChannel,&m_struRecordHostCfg,sizeof(m_struRecordHostCfg),&dwReturned))
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GET_RECORDINGHOST_CFG,  %s", "Get Record host cfg faild");
		g_StringLanType(szLan, "ȡ¼ʧ", "Get Record host cfg failed");
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GET_RECORDINGHOST_CFG,  %s", "Get Record host cfg success");
		g_StringLanType(szLan, "ȡ¼óɹ", "Get Record host cfg success");
		AfxMessageBox(szLan);
	}
	m_DelayTime = m_struRecordHostCfg.dwOneKeyDelayTime;
	m_comRecordType.SetCurSel(m_struRecordHostCfg.byDirectedMode);
	UpdateData(FALSE);
}
